# phpMyAdmin MySQL-Dump
# version 2.2.0
# http://phpwizard.net/phpMyAdmin/
# http://phpmyadmin.sourceforge.net/ (download page)
#
# : localhost
# Generation Time: March 14, 2004, 4:17 pm
# Server version: 3.23.31
# PHP Version: 4.3.4
#  : `traditions`
# --------------------------------------------------------

#
#    `banned`
#

CREATE TABLE banned (
  id int(10) NOT NULL auto_increment,
  banip varchar(15) NOT NULL default '',
  PRIMARY KEY (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
#    `forums`
#

CREATE TABLE forums (
  forum_id int(10) NOT NULL auto_increment,
  forum_name varchar(150) NOT NULL default '',
  forum_desc text NOT NULL,
  forum_order int(10) NOT NULL default '0',
  forum_icon varchar(255) NOT NULL default 'default.gif',
  PRIMARY KEY (forum_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
#    `posts`
#

CREATE TABLE posts (
  post_id int(11) NOT NULL auto_increment,
  forum_id int(10) NOT NULL default '1',
  topic_id int(10) NOT NULL default '1',
  poster_id int(10) NOT NULL default '0',
  poster_name varchar(40) NOT NULL default 'Anonymous',
  post_text text NOT NULL,
  post_time datetime NOT NULL default '0000-00-00 00:00:00',
  poster_ip varchar(15) NOT NULL default '',
  post_status tinyint(1) NOT NULL default '0',
  PRIMARY KEY (post_id),
  KEY post_id(post_id),
  KEY forum_id(forum_id),
  KEY topic_id(topic_id),
  KEY poster_id(poster_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
#    `send_mails`
#

CREATE TABLE send_mails (
  id int(11) NOT NULL auto_increment,
  user_id int(10) NOT NULL default '1',
  topic_id int(10) NOT NULL default '1',
  PRIMARY KEY (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
#    `topics`
#

CREATE TABLE topics (
  topic_id int(10) NOT NULL auto_increment,
  topic_title varchar(100) NOT NULL default '',
  topic_poster int(10) NOT NULL default '0',
  topic_poster_name varchar(40) NOT NULL default 'Anonymous',
  topic_time datetime NOT NULL default '0000-00-00 00:00:00',
  topic_views int(10) NOT NULL default '0',
  forum_id int(10) NOT NULL default '1',
  topic_status tinyint(1) NOT NULL default '0',
  topic_last_post_id int(10) NOT NULL default '1',
  PRIMARY KEY (topic_id),
  KEY topic_id(topic_id),
  KEY forum_id(forum_id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
#    `users`
#

CREATE TABLE users (
  user_id int(10) NOT NULL auto_increment,
  username varchar(40) NOT NULL default '',
  user_regdate datetime NOT NULL default '0000-00-00 00:00:00',
  user_password varchar(32) NOT NULL default '',
  user_email varchar(50) NOT NULL default '',
  user_icq varchar(15) NOT NULL default '',
  user_website varchar(100) NOT NULL default '',
  user_occ varchar(100) NOT NULL default '',
  user_from varchar(100) NOT NULL default '',
  user_interest varchar(150) NOT NULL default '',
  user_viewemail tinyint(1) NOT NULL default '0',
  user_sorttopics tinyint(1) NOT NULL default '1',
  user_newpwdkey varchar(32) NOT NULL default '',
  user_newpasswd varchar(32) NOT NULL default '',
  PRIMARY KEY (user_id)
) TYPE=MyISAM;

